.include "m8def.inc"

.org 0
   rjmp start

.org INT0addr
   rjmp INT0_vect

.org INT1addr
   rjmp INT1_vect

start:
   ldi R16,LOW(RamEnd) ;  
   out SPL,R16
   ldi R16,HIGH(RamEnd)
   out SPH,R16

   sbi DDRC,0          ;  0 - 
   sbi DDRC,1          ;  1 - 

   cbi DDRD,2          ;  D3 - 
   sbi PORTD,2         ;  D3 -  
   cbi DDRD,3          ;  D3 - 
   sbi PORTD,3         ;  D3 -  


;  GICR:     76543210
;            1---------- INT0 
;             1--------- INT1 
;
;                  1---- IVSEL
;                   1--- IVCE
   ldi R17,0b11000000
   out GICR,R17

;  MCUCR:    76543210
;                XX ----  ISC11,ISC10     INT1
;                               0     0   Low level INT1
;                               0     1   Any logical change
;                               1     0   The falling edge
;                               1     1   The rising  edge
;                  XX --  ISC01,ISC00     INT0
;                               0     0   Low level INT1
;                               0     1   Any logical change
;                               1     0   The falling edge
;                               1     1   The rising  edge
   ldi R17,0b00000000
   out MCUCR,R17

   sei

;==================================
main_loop:
   nop
   nop
   nop
   rjmp main_loop

;==================================
INT0_vect:
   sbic PORTC,0
   rjmp setC0_0
   rjmp setC0_1

setC0_0:
   cbi PORTC,0
   rjmp label0_end

setC0_1:
   sbi PORTC,0

label0_end:
   reti

;==================================
INT1_vect:
   sbic PORTC,1
   rjmp setC1_0
   rjmp setC1_1

setC1_0:
   cbi PORTC,1
   rjmp label1_end

setC1_1:
   sbi PORTC,1

label1_end:
   reti