          .nolist               ;      , ..    *.lss     
          .include "m32def.inc" ;     ATmega32
          .list                 ;      , ..    *.lss    

          .equ fCK         =  16000000             ;  
          .equ BAUD        =  9600                ;  UART  
          .equ UBRR_value  =  (fCK/(BAUD*16))-1   ;    UBRR

          .equ    D0      = 0
          .equ    D1      = 1
          .equ    D2      = 2
          .equ    D3      = 3
          .equ    D4      = 4
          .equ    D5      = 5
          .equ    D6      = 6
          .equ    D7      = 7

          .cseg      ;  ,     
          .org 0     ;  ,       0   FLASH

; 
          rjmp  init  ;   ,     - init
          rjmp  0     ;rjmp  service_INT0 ;  0
          rjmp  0     ;rjmp  service_INT1 ;  1
          rjmp  0     ;rjmp  service_OC2  ; TCNT2  OCR2
          rjmp  0     ;rjmp  service_OVF2 ; TCNT2
          rjmp  0     ;rjmp  service_ICP1 ;  ICP1
          rjmp  0     ;rjmp  service_OC1A ; TCNT1  OCR1A
          rjmp  0     ;rjmp  service_OC1B ; TCNT1  OCR1B
          rjmp  0     ;rjmp  service_OVF1 ; TCNT1
          rjmp  0     ;rjmp  service_OVF0 ; TCNT0
          rjmp  0     ;rjmp  service_SPI  ;   SPI
          rjmp  USART_RXC ;   USART
          rjmp  0     ;rjmp  service_UDRE ; UDR  USART
          rjmp  0     ;rjmp  service_UTXC ;   USART
          rjmp  0     ;rjmp  service_ADCC ;  
          rjmp  0     ;rjmp  service_ERDY ;   EEPROM
          rjmp  0     ;rjmp  service_ACI  ;  
          rjmp  0     ;rjmp  service_TWI  ;   TWI
          rjmp  0     ;rjmp  service_SPMR ;  spm

; 
init:
          ldi   R16,low(RAMEND)    ;  R16     RAMEND,    m8def.inc    SRAM
          out   SPL,R16            ;   R16  SPL
          ldi   R17,high(RAMEND)   ;  R16     RAMEND,    m8def.inc
          out   SPH,R17            ;   R17  SPH

;  
main:
;    // 
      rcall init_PORTS

      rcall init_USART
      ldi   R16,'T'
      rcall USART_send
      ldi   R16,'E'
      rcall USART_send
      ldi   R16,'S'
      rcall USART_send
      ldi   R16,'T'
      rcall USART_send
      ldi   R16,':'
      rcall USART_send
      ldi   R16,' '
      rcall USART_send      ; SPACE
  ;  
      SEI
loop:
      SBIS  UCSRA, RXC
      RJMP  UART_No
      IN    R16, UDR
      rcall USART_send
      ldi   R16,' '
      rcall USART_send      ; SPACE
UART_No:
      in      R16, PIND
      RCALL   WAIT_20ms
      out     PORTA, R16
      RCALL   WAIT_20ms
      rjmp  loop

;=================================================
;      UART
USART_RXC:
      sbi   PORTB, D1
      PUSH  R16
      IN    R16,SREG
      PUSH  R16
      rcall UART_Receive
      rcall WAIT_20ms
      rcall USART_send
      ldi   R16,' '
      rcall USART_send      ; SPACE
      POP   R16
      OUT   SREG,R16
      POP   R16
      cbi   PORTB, D1
RETI

;=================================================
init_PORTS:
    RCALL   WAIT_20ms

    cbi     DDRD, D2  ;   D -  
    cbi     DDRD, D3
    cbi     DDRD, D4
    cbi     DDRD, D5
    cbi     DDRD, D6
    cbi     DDRD, D7

    sbi     PORTD, D2  ;   D  
    sbi     PORTD, D3
    sbi     PORTD, D4
    sbi     PORTD, D5
    sbi     PORTD, D6
    sbi     PORTD, D7

    sbi     DDRB, D0   ;   B  
    sbi     DDRB, D1
    sbi     DDRB, D2
    sbi     DDRB, D3
    sbi     DDRB, D4
    sbi     DDRB, D5
    sbi     DDRB, D6             ;
    sbi     DDRB, D7

    cbi     PORTB, D0   ;   D ;
    cbi     PORTB, D1
    cbi     PORTB, D2
    cbi     PORTB, D3
    cbi     PORTD, D4
    cbi     PORTB, D5
    cbi     PORTB, D6             ;
    cbi     PORTB, D7

    sbi     DDRA, D0   ;     
    sbi     DDRA, D1
    sbi     DDRA, D2
    sbi     DDRA, D3
    sbi     DDRA, D4
    sbi     DDRA, D5
    sbi     DDRA, D6
    sbi     DDRA, D7
    ret

;  USART 
init_USART:
      ldi   R16,high(UBRR_value)   ;  9600 
      out   UBRRH,R16
      ldi   R16,low(UBRR_value)
      out   UBRRL,R16

      ldi   R16,(1<<TXEN)|(1<<RXEN) ;    
      out   UCSRB,R16

      ldi   R16,(1<< URSEL)|(1<< UCSZ0)|(1<< UCSZ1)
      out   UCSRC,R16 ;  8  ,   ,  
      ret
;  
USART_send:
      sbis  UCSRA,UDRE            ;   UDRE  UCSRA   
      rjmp  USART_send
      out   UDR,R16               ;   UART,     UDR
      ret
;  
UART_Receive:
      SBIS  UCSRA, RXC
      RJMP  UART_Receive
      IN    R16, UDR
      ret

;=================================================
;// 
WAIT_20ms:
; =============================
;    delay loop generator
;     160000 cycles:
; -----------------------------
; delaying 159975 cycles:
          ldi  R17, $E1
WGLOOP01: ldi  R18, $EC
WGLOOP11: dec  R18
          brne WGLOOP11
          dec  R17
          brne WGLOOP01
; -----------------------------
; delaying 24 cycles:
          ldi  R17, $08
WGLOOP21: dec  R17
          brne WGLOOP21
; -----------------------------
; delaying 1 cycle:
          nop
; =============================
          ret

WAIT_5ms:
; =============================
;    delay loop generator
;     40000 cycles:
; -----------------------------
; delaying 39999 cycles:
          ldi  R17, $43
WGLOOP02: ldi  R18, $C6
WGLOOP12: dec  R18
          brne WGLOOP12
          dec  R17
          brne WGLOOP02
; -----------------------------
; delaying 1 cycle:
          nop
; =============================
          ret

;//----------------------------------
WAIT_100us:
; =============================
;    delay loop generator
;     800 cycles:
; -----------------------------
; delaying 798 cycles:
          ldi  R17, $02
WGLOOP03: ldi  R18, $84
WGLOOP13: dec  R18
          brne WGLOOP13
          dec  R17
          brne WGLOOP03
; -----------------------------
; delaying 2 cycles:
          nop
          nop
; =============================
          ret