          .nolist               ;      , ..    *.lss     
          .include "m32def.inc" ;     ATmega32
          .list                 ;      , ..    *.lss    

          .equ fCK         =  16000000             ;  
          .equ BAUD        =  9600                ;  UART  
          .equ UBRR_value  =  (fCK/(BAUD*16))-1   ;    UBRR

          .equ    D0      = 0
          .equ    D1      = 1
          .equ    D2      = 2
          .equ    D3      = 3
          .equ    D4      = 4
          .equ    D5      = 5
          .equ    D6      = 6
          .equ    D7      = 7

          .cseg      ;  ,     
          .org 0     ;  ,       0   FLASH

; 
          rjmp  init  ;   ,     - init
          nop
          nop
          nop
          nop
          nop
          nop
          nop
          nop
          nop
          nop
          nop
          nop
          nop
          nop
          nop
          nop
          nop
          nop
          nop
          nop
          nop
          nop
          nop
          nop
          nop
          nop
          nop
          nop
          nop
          nop
          nop
          nop
          nop
          nop
          nop
          nop
          nop
          nop
          nop
          nop

         .org $0030     ;  ,        30h
;=================================================
;      UART
USART_RXC:
      sbi   PORTB, D1
      IN    R16, UDR
;      rcall USART_send
;      ldi   R16,' '
;      rcall USART_send      ; SPACE
      cbi   PORTB, D1
      SEI
      RET

      PUSH  R16
      IN    R16,SREG
      PUSH  R16

      POP   R16
      OUT   SREG,R16
      POP   R16

;=================================================
; 
init:
      ldi   R16,low(RAMEND)    ;  R16     RAMEND,    m8def.inc    SRAM
      out   SPL,R16            ;   R16  SPL
      ldi   R17,high(RAMEND)   ;  R16     RAMEND,    m8def.inc
      out   SPH,R17            ;   R17  SPH

;  
main:
;    //  I/O ;
      rcall init_PORTS
;    // USART ;
      rcall init_USART
      ldi   R16,'T'
      rcall USART_send
      ldi   R16,'E'
      rcall USART_send
      ldi   R16,'S'
      rcall USART_send
      ldi   R16,'T'
      rcall USART_send
      ldi   R16,':'
      rcall USART_send
      ldi   R16,' '
      rcall USART_send      ; SPACE
  ;  
      SEI
loop:
;      RJMP  UART_No
      SBIS  UCSRA, RXC
      RJMP  UART_No
      IN    R16, UDR
      rcall USART_send
      ldi   R16,' '
      rcall USART_send      ; SPACE
UART_No:
      in      R16, PIND
      RCALL   WAIT_20ms
      out     PORTA, R16
      RCALL   WAIT_20ms
      rjmp  loop

          rjmp  0     ;rjmp  service_INT0 ;  0
          nop
          rjmp  0     ;rjmp  service_INT1 ;  1
          nop
          rjmp  0     ;rjmp  service_OC2  ; TCNT2  OCR2
          nop
          rjmp  0     ;rjmp  service_OVF2 ; TCNT2
          nop
          rjmp  0     ;rjmp  service_ICP1 ;  ICP1
          nop
          rjmp  0     ;rjmp  service_OC1A ; TCNT1  OCR1A
          nop
          rjmp  0     ;rjmp  service_OC1B ; TCNT1  OCR1B
          nop
          rjmp  0     ;rjmp  service_OVF1 ; TCNT1
          nop
          rjmp  0     ;rjmp  service_OVF0 ; TCNT0
          nop
          rjmp  0     ;rjmp  service_SPI  ;   SPI
          nop
          rjmp  USART_RXC ;   USART
          nop
          rjmp  0     ;rjmp  service_UDRE ; UDR  USART
          nop
          rjmp  0     ;rjmp  service_UTXC ;   USART
          nop
          rjmp  0     ;rjmp  service_ADCC ;  
          nop
          rjmp  0     ;rjmp  service_ERDY ;   EEPROM
          nop
          rjmp  0     ;rjmp  service_ACI  ;  
          nop
          rjmp  0     ;rjmp  service_TWI  ;   TWI
          nop
          rjmp  0     ;rjmp  service_SPMR ;  spm
          nop

;=================================================
init_PORTS:
    RCALL   WAIT_20ms

    cbi     DDRD, D2  ;   D -  
    cbi     DDRD, D3
    cbi     DDRD, D4
    cbi     DDRD, D5
    cbi     DDRD, D6
    cbi     DDRD, D7

    sbi     PORTD, D2  ;   D  
    sbi     PORTD, D3
    sbi     PORTD, D4
    sbi     PORTD, D5
    sbi     PORTD, D6
    sbi     PORTD, D7

    sbi     DDRB, D0   ;   B  
    sbi     DDRB, D1
    sbi     DDRB, D2
    sbi     DDRB, D3
    sbi     DDRB, D4
    sbi     DDRB, D5
    sbi     DDRB, D6             ;
    sbi     DDRB, D7

    cbi     PORTB, D0   ;   D ;
    cbi     PORTB, D1
    cbi     PORTB, D2
    cbi     PORTB, D3
    cbi     PORTD, D4
    cbi     PORTB, D5
    cbi     PORTB, D6             ;
    cbi     PORTB, D7

    sbi     DDRA, D0   ;     
    sbi     DDRA, D1
    sbi     DDRA, D2
    sbi     DDRA, D3
    sbi     DDRA, D4
    sbi     DDRA, D5
    sbi     DDRA, D6
    sbi     DDRA, D7
    ret

;  USART 
init_USART:
      ldi   R16,high(UBRR_value)   ;  9600 
      out   UBRRH,R16
      ldi   R16,low(UBRR_value)
      out   UBRRL,R16

;           RXCIE       -      
;           |TXCIE      -      
;           ||UDRIE     -       
;           |||RXEN     -    
;           ||||TXEN    -    
;           |||||UCSZ2  -   UCSZ0:2   
;           ||||||RXB8  -   9   
;           |||||||TXB8 -   9   
;     BIT:  76543210
      ldi   R16,(1<<TXEN)|(1<<RXEN)|(1<<RXCIE) ;    
      out   UCSRB,R16

      ldi   R16,(1<< URSEL)|(1<< UCSZ0)|(1<< UCSZ1)
      out   UCSRC,R16 ;  8  ,   ,  
      ret
;  
USART_send:
      sbis  UCSRA,UDRE            ;   UDRE  UCSRA   
      rjmp  USART_send
      out   UDR,R16               ;   UART,     UDR
      ret
;  
UART_Receive:
      SBIS  UCSRA, RXC
      RJMP  UART_Receive
      IN    R16, UDR
      ret

;=================================================
;// 
WAIT_20ms:
; =============================
;    delay loop generator
;     160000 cycles:
; -----------------------------
; delaying 159975 cycles:
          ldi  R17, $E1
WGLOOP01: ldi  R18, $EC
WGLOOP11: dec  R18
          brne WGLOOP11
          dec  R17
          brne WGLOOP01
; -----------------------------
; delaying 24 cycles:
          ldi  R17, $08
WGLOOP21: dec  R17
          brne WGLOOP21
; -----------------------------
; delaying 1 cycle:
          nop
; =============================
          ret

WAIT_5ms:
; =============================
;    delay loop generator
;     40000 cycles:
; -----------------------------
; delaying 39999 cycles:
          ldi  R17, $43
WGLOOP02: ldi  R18, $C6
WGLOOP12: dec  R18
          brne WGLOOP12
          dec  R17
          brne WGLOOP02
; -----------------------------
; delaying 1 cycle:
          nop
; =============================
          ret

;//----------------------------------
WAIT_100us:
; =============================
;    delay loop generator
;     800 cycles:
; -----------------------------
; delaying 798 cycles:
          ldi  R17, $02
WGLOOP03: ldi  R18, $84
WGLOOP13: dec  R18
          brne WGLOOP13
          dec  R17
          brne WGLOOP03
; -----------------------------
; delaying 2 cycles:
          nop
          nop
; =============================
          ret